/*
 * 牌类，包括牌和点数，每张牌的点数由两个一到六的数字组成
 */

function Card(count1,count2){
	var self = this; 
	base(self,LSprite,[]);
	
	self.count1 = count1;
	self.count2 = count2;
	
	//背面
	self.back = new MiddleBitmap(new LBitmapData(imglist["pokerBg"]));
	self.back.scaleY = 0.8;
	self.addChild(self.back);
	
	//正面
	self.front = new MiddleBitmap(new LBitmapData(imglist["pokerFront"]));
	self.front.scaleY = 0.8;
	self.front.visible = false;
	self.addChild(self.front);
	
	//点数1
	self.frontCount1 = new MiddleBitmap(new LBitmapData(imglist["poker"+count1]));
	self.frontCount1.x = 0;
	self.frontCount1.y = -24;
	self.frontCount1.scaleY = 0.8;
	//self.frontCount1 = false;
	self.front.addChild(self.frontCount1);
	
	//点数2
	self.frontCount2 = new MiddleBitmap(new LBitmapData(imglist["poker"+count2]));
	self.frontCount2.x = 0;
	self.frontCount2.y = 24;
	self.frontCount2.scaleY = 0.8;
	//self.frontCount2 = false;
	self.front.addChild(self.frontCount2);	
	
	//测试代码
	self.startFlipX();
};


Card.prototype.startFlipX = function(){  
	var self = this; 
	LTweenLite.to(self.back,0.2,{scaleX:0.1,scaleY:0.8,ease:Bounce.easeIn,onComplete:function(){
		self.showFront();
	}});
}

Card.prototype.showFront = function(){ 
	var self = this; 
	self.back.visible = false;
	self.front.visible = true;
	self.front.scaleX = 0.1;
	
	LTweenLite.to(self.front,0.1,{scaleX:1.0,scaleY:0.8,ease:Bounce.easeIn})
	.to(self.front,0.1,{scaleX:0.8,scaleY:0.8,ease:Bounce.easeIn,onComplete:function(){
		//翻牌结束，通知显示下一张牌等
	}});
}
